﻿
@{
    ViewBag.Title = "List";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

@section HeadLibrary{

    <link rel="stylesheet" href="~/adminlte/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/adminlte//plugins/datatables-responsive/css/responsive.bootstrap4.min.css">

    <link rel="stylesheet" href="~/adminlte/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">

    <link rel="stylesheet" href="~/adminlte/plugins/toastr/toastr.min.css">


    <link rel="stylesheet" href="~/adminlte/plugins/icheck-bootstrap/icheck-bootstrap.min.css">

    <link rel="stylesheet" href="~/adminlte/plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">

    <link rel="stylesheet" href="~/adminlte/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/adminlte/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">

    <link rel="stylesheet" href="~/adminlte/plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">

    <link rel="stylesheet" href="~/adminlte/css/adminlte.min.css">
}

<div class="card">
    <div class="card-header">
        <button id="addOrder" class="btn btn-primary" data-toggle="modal" data-target="#modalAddOrder"><i class="fas fa-plus-circle mr-1"></i>Create New Order</button>
    </div>
    <div class="card-body">
        <table id="user-table" class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>Order Number</th>
                    <th>Customer ID</th>
                    <th>Customer Name</th>
                    <th>PO Number</th>
                    <th>Order Date</th>
                    <th>Need By Date</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
</div>

<div class="modal fade" id="modalAddOrder" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <form class="form-parsley" id="form-create">
                <div class="modal-header px-4 bg-light">
                    <h4 class="modal-title" id="addModalLabel">Add New Order</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
                <div class="modal-body p-4">
                    <div class="row">
                        <div class="col-sm-12">
                            <div class="form-group">
                                <label for="OrderNum">Order Number *</label>
                                <input type="text" class="form-control" id="OrderNum" name="OrderNum" placeholder="Order Number" autocomplete="off" required>
                            </div>
                            <div class="form-group">
                                <label for="CustID">Customer ID *</label>
                                <input type="text" class="form-control" id="CustID" name="CustID" placeholder="Customer Id" autocomplete="off" required>
                            </div>
                            <div class="form-group">
                                <label for="CustName">Customer Name *</label>
                                <input type="text" class="form-control" id="CustName" name="CustName" placeholder="Customer Name" autocomplete="off" required>
                            </div>
                            <div class="form-group">
                                <label for="PONum">PO Number *</label>
                                <input type="text" class="form-control" id="PONum" name="PONum" placeholder="PO Number" autocomplete="off" required>
                            </div>
                            <div class="form-group">
                                <label for="OrderDate">Order Date *</label>
                                <input type="date" class="form-control" id="OrderDate" name="OrderDate" placeholder="Order Date" autocomplete="off" required>
                            </div>
                            <div class="form-group">
                                <label for="NeedByDate">Need By Date *</label>
                                <input type="date" class="form-control" id="NeedByDate" name="NeedByDate" placeholder="Need By Date" autocomplete="off" required>
                            </div>
                        </div>
                    </div>
                    <div class="text-right mt-2">
                        <button type="button" class="btn btn-danger waves-effect waves-light" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary btn-waves-effect waves-light">
                            Submit
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

<div class="modal fade" id="modalEditUser" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <form class="form-parsley" id="form-edit">
                    <div class="modal-header px-4 bg-light">
                        <h4 class="modal-title" id="addModalLabel">Add New Order</h4>
                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                    </div>
                    <div class="modal-body p-4">
                        <div class="row">
                            <div class="col-sm-12">
                                <div class="form-group">
                                    <label for="EditOrderNum">Order Number *</label>
                                    <input type="text" class="form-control" id="EditOrderNum" name="OrderNum" placeholder="Order Number" autocomplete="off" required>
                                </div>
                                <div class="form-group">
                                    <label for="EditCustID">Customer ID *</label>
                                    <input type="text" class="form-control" id="EditCustID" name="CustID" placeholder="Customer Id" autocomplete="off" required>
                                </div>
                                <div class="form-group">
                                    <label for="EditCustName">Customer Name *</label>
                                    <input type="text" class="form-control" id="EditCustName" name="CustName" placeholder="Customer Name" autocomplete="off" required>
                                </div>
                                <div class="form-group">
                                    <label for="EditPONum">PO Number *</label>
                                    <input type="text" class="form-control" id="EditPONum" name="PONum" placeholder="PO Number" autocomplete="off" required>
                                </div>
                                <div class="form-group">
                                    <label for="EditOrderDate">Order Date *</label>
                                    <input type="date" class="form-control" id="EditOrderDate" name="OrderDate" placeholder="Order Date" autocomplete="off" required>
                                </div>
                                <div class="form-group">
                                    <label for="EditNeedByDate">Need By Date *</label>
                                    <input type="date" class="form-control" id="EditNeedByDate" name="NeedByDate" placeholder="Need By Date" autocomplete="off" required>
                                </div>
                            </div>
                        </div>
                        <div class="text-right mt-2">
                            <button type="button" class="btn btn-danger waves-effect waves-light" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary btn-waves-effect waves-light">
                                Submit
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>

@section BodyLibrary{
     @*DataTables*@ 
    <script src="@Url.Content("~/adminlte/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
     @*SweetAlert2*@ 
    <script src="@Url.Content("~/adminlte/plugins/sweetalert2/sweetalert2.min.js")"></script>
     @*Toastr*@ 
    <script src="@Url.Content("~/adminlte/plugins/toastr/toastr.min.js")"></script>
     @*DataRender*@ 
    <script src="@Url.Content("~/adminlte/plugins/dataRender/dateTime.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/jsgrid/demos/db.js")"></script>
    <script src="@Url.Content("~/adminlte/plugins/jsgrid/jsgrid.min.js")"></script>
     @*Select2*@ 
    <script src="@Url.Content("~/adminlte/plugins/select2/js/select2.full.min.js")"></script>
     @*Bootstrap Switch*@ 
    <script src="@Url.Content("~/adminlte/plugins/bootstrap-switch/js/bootstrap-switch.min.js")"></script>
     @*bootstrap color picker*@ 
    <script src="@Url.Content("~/adminlte/plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js")"></script>
     @*Select2*@ 
    <script src="~/adminlte/plugins/select2/js/select2.full.min.js"></script>
     @*jquery-validation*@ 
    <script src="~/adminlte/plugins/jquery-validation/jquery.validate.min.js"></script>
    <script src="~/adminlte/plugins/jquery-validation/additional-methods.min.js"></script>
}

@section scripts{
    <script>
        var NUMBER_ORDER;
        var RETURNURL = "https://localhost:44334/Order/List";
        $(document).ready(function () {

            //Tampilkan semua order
            $.ajax({
                url: "GetAllOrder",
                type: "post",
                dataType: "json",
                success: function (data) {
                    $("#user-table").DataTable({
                        data: data.response,
                        "columnDefs": [
                            {
                                "targets": 4,
                                "render": function (data) {
                                    return moment(data).format('DD-MMM-YYYY') ;
                                },
                            },
                            {
                                "targets": 5,
                                "render": function (data) {
                                    return moment(data).format('DD-MMM-YYYY');
                                },
                            }
                        ],
                        columns: [
                            //{ 'data': 'OrderNum' },
                            //{ 'data': 'CustID' },
                            //{ 'data': 'CustName' },
                            //{ 'data': 'PONum' },
                            //{ 'data': 'OrderDate' },
                            //{ 'data': 'NeedByDate' },
                            { "data": "OrderNum", "name": "OrderNum" },
                            { "data": "CustID", "name": "CustID" },
                            { "data": "CustName", "name": "CustName" },
                            { "data": "PONum", "name": "PONum" },
                            { "data": "OrderDate", "name": "OrderDate" },
                            { "data": "NeedByDate", "name": "NeedByDate" },
                            {
                                "searchable": false, "orderable": false, "sClass": "text-center", "width": "16%", "render": function (data, type, row) {
                                    return '<button type="button" data="' + row.OrderNum + '" class="btn btn-xs btn-success waves-effect waves-light mr-1" onclick="editUser(this,event);" style="width : 40%">Edit</button><button type="button" data="' + row.OrderNum + '" class="btn btn-xs btn-danger waves-effect waves-light" onclick="deleteUser(this,event);" style="width : 40%">Delete</button>';
                                }
                            },
                        ]
                    });
                },
                error: function (result) {
                    alert("error");
                    console.log(result);
                },
            });
        });

        $("#form-create").submit(function (event) {
            event.preventDefault();
            $.ajax({
                url: "Create",
                type: "post",
                dataType: "json",
                data: $(this).serialize(),
                beforeSend: function () {
                    Swal.fire({
                        title: 'Saving...',
                        html: "Save Order details.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    if (data.metaData.code == 200) {
                        $('#modalAddUser').modal('hide');
                        messageSuccess(data.metaData.message, RETURNURL);
                    } else {
                        $('#modalAddUser').modal('hide');
                        messageFailed(data.metaData.message, null);
                    }
                },
                error: function (result) {
                    console.log("error", result);
                }
            });
        });

        $("#form-edit").submit(function (event) {
            event.preventDefault();
            let numberOrder = NUMBER_ORDER;
            let formData = new FormData();
            formData.append("OrderNum", numberOrder);
            formData.append("CustName", $("#EditCustName").val());
            formData.append("CustID", $("#EditCustID").val());
            formData.append("PONum", $("#EditPONum").val());
            formData.append("OrderDate", $("#EditOrderDate").val());
            formData.append("NeedByDate", $("#EditNeedByDate").val());

            $.ajax({
                url: "Update/" + numberOrder,
                type: "post",
                dataType: "json",
                data: formData,
                processData: false,
                processData: false,
                contentType: false,
                beforeSend: function () {
                    Swal.fire({
                        title: 'Updating',
                        html: "Update User details.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    if (data.metaData.code == 200) {
                        $('#modalEditUser').modal('hide');
                        messageSuccess(data.metaData.message, RETURNURL);
                    } else {
                        $('#modalEditUser').modal('hide');
                        messageFailed(data.metaData.message, null);
                    }
                },
                error: function (result) {
                    console.log("error", result);
                }
            });
        });

        window.editUser = (input, evt) => {
            let numberOrder = $(input).attr('data');
            NUMBER_ORDER = numberOrder;
             $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Content("~/Order/AmbilOrder")',
                dataType: 'JSON',
                type: 'POST',
                data: JSON.stringify({ "numberOrder": numberOrder }),
                success: function (data) {
                    let order = data.response;
                    $("#EditOrderNum").val(order.OrderNum);
                    $("#EditCustName").val(order.CustName);
                    $("#EditCustID").val(order.CustID);
                    $("#EditPONum").val(order.PONum);
                    $("#EditOrderDate").val(moment(order.OrderDate).format('DD-MMM-YYYY'));
                    $("#EditNeedByDate").val(moment(order.NeedByDate).format('DD-MMM-YYYY'));
                    $('#modalEditUser').modal('show');
                },
                error: function (error) {
                    alert("error" + error);
                }
            })
        }

        window.deleteUser = (input, evr) => {
            let numberOrder= $(input).attr('data');
            Swal.fire({
                title: 'Delete User',
                icon: "warning",
                text: 'User ini Akan dihapus, Anda yakin??',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                cancelButtonText: 'Cancel',
                confirmButtonText: 'Yes (Delete)',
                showLoaderOnConfirm: true,
                preConfirm: (login) => {
                    return $.ajax({
                        url: '@Url.Content("~/Order/Delete")',
                        type: "post",
                        dataType: "json",
                        data: JSON.stringify({ "numberOrder": numberOrder }),
                        contentType: 'application/JSON; charset=utf-8'
                    }).then(response => {
                        if (!response.ok) {
                            messageFailed(response.statusText)
                        }
                        return response;
                    }).then(result => {
                        if (result.metaData.code === 200) {
                            messageSuccess(result.metaData.message, RETURNURL)
                        } else {
                            messageFailed(result.metaData.message)
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }
    </script>
}